/*
	File:			ydkmain68k.c	

	Description:	Contains the 68K portion of the Palm ARMlet.  It sets up a form so that
					the UI works with the Palm UI, and it calls the ARMlet.

	Author:		

	Copyright:		Copyright  2003 by Tapwave, Inc.

	Disclaimer:		IMPORTANT:  This Tapwave software is provided by Tapwave, Inc. ("Tapwave").  Your 
					use is subject to and governed by terms and conditions of the Software Development 
					Kit Agreement ("SDK Agreement") between you and Tapwave.  If you have not entered 
					into Tapwaves standard SDK Agreement with Tapwave, you have no right or license 
					to use, reproduce, modify, distribute or otherwise exploit this Tapwave software.  
					You may obtain a copy of Tapwaves standard SDK Agreement by calling 650-960-1817
					or visiting Tapwave at http://www.tapwave.com/developers/. 

	Change History (most recent first):
				
*/

//#define TESTING_ONLY

#include <PalmOS.h>
#include <VFSMgr.h>
#include <StringMgr.h>
#include <PCENativeCall.h>
#include "ydk_pnoload.h"
#include "pnobridge.h"

#include <coretraps.h>

#include "TapWave/TwChars.h"
#include "stdfile.h"
#include "host68k.h"
#include "display68k.h"
#include "AppRsc.h"

//#include "palm5way.h"
#include <TwKeys.h>


// Define the minimum OS version we support (2.0 for now).
#define kPalmOS10Version	sysMakeROMVersion(1,0,0,sysROMStageRelease,0)


int g_iwad_entries,g_pwad_entries;
char **g_iwad_listchoice,**g_pwad_listchoice;
int p_video_x,p_video_y,p_video_rot;


char device_type;

char g_launch_pno;
extern UInt32 hw_flags;
char g_consoleCmd[256];

zhexen_pref_t g_zhexen_pref;

/**********************************/

typedef struct {UInt32 val;char *label;} t_hardkey;
t_hardkey hardkeys[]={
{keyBitPower,"Power"},
{keyBitPageUp,"Pg up"},
{keyBitPageDown,"Pg down"},
{keyBitHard1,"Hard1"},
{keyBitHard2,"Hard2"},
{keyBitHard3,"Hard3"},
{keyBitHard4,"Hard4"},
{keyBitCradle,"Cradle"},
{keyBitAntenna,"Antenna"},
{keyBitContrast,"Contrast"},
{keyBitNavUp,"Nav Up"},
{keyBitNavDown,"Nav Down"},
{keyBitNavLeft,"Nav Left"},
{keyBitNavRight,"Nav Right"},
{keyBitNavSelect,"Nav Select"},
{keyBitActionA,"Action A"},
{keyBitActionB,"Action B"},
{keyBitActionC,"Action C"},
{keyBitActionD,"Action D"},
{keyBitTriggerA,"Trig Left"},
{keyBitTriggerB,"Trig Right"},
{keyBitFunction,"Function"},
{keyBitLaunch,"Launch"},
{0,""}
};


	
void garbage_collect ( void );
void LoadZippedModuleFromCard(/*UInt16 id*/char *name);
UInt32 UnzipToFtr(char *name,UInt16 Ftr);

#define SET_FRM_COLORS() { \
			RGBColorType col;\
			Int16 cr,cg,cb,cr2,cg2,cb2;\
			cr=40;cg=40;cb=40;\
			col.r=cr;col.g=cg;col.b=cb;\
			UIColorSetTableEntry(UIFormFill,&col);\
			UIColorSetTableEntry(UIFieldBackground,&col);\
			col.r>>=1;col.g>>=1;col.b>>=1;\
			UIColorSetTableEntry(UIFormFrame,&col);\
			UIColorSetTableEntry(UIDialogFill,&col);\
			cr2=80;cg2=80;cb2=80;\
			col.r=cr2;col.g=cg2;col.b=cb2;\
			UIColorSetTableEntry(UIObjectFill,&col);\
			col.r=(cr+cr2)>>1;\
			col.g=(cg+cr2)>>1;\
			col.b=(cb+cr2)>>1;\
			UIColorSetTableEntry(UIObjectFrame,&col);\
			cr=200;cg=200;cb=200;\
			col.r=cr;col.g=cg;col.b=cb;\
			UIColorSetTableEntry(UIObjectForeground,&col); \
			UIColorSetTableEntry(UIFieldText,&col); \
			UIColorSetTableEntry(UIFieldTextLines,&col); \
			UIColorSetTableEntry(UIFieldCaret,&col); \
			}


#define ASK_FOR_UPDATE \
	{EventType my_event; \
	my_event.eType=frmUpdateEvent;\
	EvtAddEventToQueue(&my_event);}


#define DRAW_LOGO(X,Y)\
	{\
		MemHandle hRsc=NULL;\
		hRsc = DmGetResource(bitmapRsc, LOGOBMP);\
		if (hRsc)\
		{	BitmapType* bitmapP = (BitmapType*) MemHandleLock(hRsc);\
			WinPaintBitmap(bitmapP, X, Y);\
			MemHandleUnlock(hRsc);\
			DmReleaseResource(hRsc);}\
	}


void	drawList	(Int16	i,RectangleType	*bounds,Char		**items,int num_entries,char **listchoice)
	{
	Char *p,q[64];	
	Int16 j=0;
	Int16 wid;
	Boolean notruncated;
	IndexedColorType selectColor = UIColorGetTableEntryIndex(UIObjectSelectedForeground);
	IndexedColorType myColor=0;
	IndexedColorType itemColor = WinSetForeColor(myColor);	
	RGBColorType fg,bg;	
	
	WinSetForeColor(itemColor);	
	if (i>=num_entries) return;	
	p=listchoice[i]/*+1*/;
		
	while (p[j++]);
	
	WinPushDrawState();	
    WinSetDrawMode(winPaint);
    
	j--;    
	
	switch (listchoice[i][0]) {
		case 3: //SLOT 2
			fg.r=120;fg.g=60;fg.b=240;
		break;
		case 2: //SLOT 1
			fg.r=130;fg.g=150;fg.b=60;
		break;
		case 1:
		default:  //SLOT 0 (internal)
			fg.r=60;fg.g=160;fg.b=80;
		break;
	}
	
	bg.r=255;bg.g=255;bg.b=255;       
	
    if (((p[j-1]=='P')||(p[j-1]=='p'))&&((p[j-2]=='I')||(p[j-2]=='i'))&&((p[j-3]=='Z')||(p[j-3]=='z'))) {
	    //FntSetFont(boldFont);
	}
	else{
	    UInt16 cr=(UInt16)(fg.r)*4/3;
	    UInt16 cg=(UInt16)(fg.g)*4/3;
	    UInt16 cb=(UInt16)(fg.b)*4/3;
	    if (cr>255) cr=255;if (cg>255) cg=255;if (cb>255) cb=255;
	    fg.r=cr;fg.b=cb;fg.b=cb;
//		fg.r<<=1;fg.g<<=1;fg.b<<=1;
	}   
	
	if (itemColor == selectColor) {
	    fg.r^=255;fg.g^=255;fg.b^=255;
		bg.r^=255;bg.g^=255;bg.b^=255;
	}
	        	
    WinSetTextColorRGB(&fg,NULL);    
//    WinSetBackColorRGB(&bg,NULL);


	wid=100;
	FntCharsInWidth(p,&wid,&j,&notruncated);
	if (!notruncated){
		if (j>63) {j=63;DEBUGS("drawList => truncated string with > 63chars");}
		p=q;//(Char*)MemPtrNew(j);
		MemMove(p,listchoice[i]+3,j);
		p[j]=0;
		p[j-1]='.';p[j-2]='.';p[j-3]='.';
	}
	
	
	WinSetCoordinateSystem(kCoordinatesNative);
	
	WinPaintChars(p,j,bounds->topLeft.x*2,
			bounds->topLeft.y*2);
			
	WinSetDrawMode(winOverlay);
	
	if (itemColor == selectColor){
	fg.r<<=1;fg.g<<=1;fg.b<<=1;
    WinSetTextColorRGB(&fg,NULL);
	WinPaintChars(p,j,bounds->topLeft.x*2-1,
			bounds->topLeft.y*2-1);
	}		
//	if (!notruncated) MemPtrFree(p);
	WinPopDrawState();	
}

void	drawIWADList	(Int16	i,RectangleType	*bounds,Char		**items){
	drawList(i,bounds,items,g_iwad_entries,g_iwad_listchoice);
}
void	drawPWADList	(Int16	i,RectangleType	*bounds,Char		**items){
	drawList(i,bounds,items,g_pwad_entries,g_pwad_listchoice);
}



/***********************************************************************
 *
 * FUNCTION:    BlankFormHandleEvent
 *
 * DESCRIPTION: This routine is the event handler for the "BlankForm" of this 
 * 				application.
 *
 * PARAMETERS:  eventP - A pointer to the EventType structure.
 *
 * RETURNED:    true if the event was handled and should be passed to
 *				FrmHandleEvent.
 *
 ***********************************************************************/
Boolean BlankFormHandleEvent(EventType * eventP)
{
	Boolean 		handled = false;
	FormType* 		frmP = FrmGetActiveForm();
	UInt32 			flags, pinMgrVersion;
	Err			err = errNone;

	switch (eventP->eType) {
		case frmOpenEvent:{	
			ListType *list;			
			
			SET_FRM_COLORS()
			FrmDrawForm(frmP);		
			
			
			

			
			LstNewList((void**)&frmP,FORM_LISTFILE_ID,50,44,100,80,FntGetFont(),4,0);
			list=(ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTFILE_ID) );
			LstSetDrawFunction (list, (ListDrawDataFuncPtr) drawIWADList);
			InitFileList(list,&g_iwad_entries,&g_iwad_listchoice,g_zhexen_pref.g_iwad_name);
			
			LstNewList((void**)&frmP,FORM_LISTPATCHFILE_ID,50,93,100,80,FntGetFont(),4,0);
			list=(ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTPATCHFILE_ID) );
			LstSetDrawFunction (list, (ListDrawDataFuncPtr) drawPWADList);						
			InitFileList(list,&g_pwad_entries,&g_pwad_listchoice,g_zhexen_pref.g_pwad_name);			
			
			if (g_zhexen_pref.g_pwad_active){
				FrmShowObject(frmP,FrmGetObjectIndex(frmP,FORM_LISTPATCHFILE_ID));
			}else{
				FrmHideObject(frmP,FrmGetObjectIndex(frmP,FORM_LISTPATCHFILE_ID));
			}
			
			
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,PWADCHECK),g_zhexen_pref.g_pwad_active);
			
			
			if (!(g_zhexen_pref.first)){
	   			menu_inform(WELCOME_MSG);
	   			g_zhexen_pref.first=1;
	   		}
			
			ASK_FOR_UPDATE

			handled = true;
			break;
		}
		case frmCloseEvent:{
			ListType *list;
			Int16 idx;
			list=(ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTFILE_ID) );
			if (list) {
			
				idx=LstGetSelection(list);
				if ((idx>=0)&&(idx<g_iwad_entries)){
					StrCopy(g_zhexen_pref.g_iwad_name,(g_iwad_listchoice[idx]));
				}
			
				LstEraseList(list);
				LstSetListChoices(list,(char**)NULL,0);										
				if (g_iwad_listchoice) {
					int i;
					for (i=0;i<g_iwad_entries;i++)
						MemPtrFree(g_iwad_listchoice[i]);
					MemPtrFree(g_iwad_listchoice);
					g_iwad_listchoice=NULL;
				}				
				garbage_collect();
			}													
			list=(ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTPATCHFILE_ID) );
			if (list) {
			
				idx=LstGetSelection(list);
				if ((idx>=0)&&(idx<g_iwad_entries)&&g_zhexen_pref.g_pwad_active){
					StrCopy(g_zhexen_pref.g_pwad_name,(g_pwad_listchoice[idx]));
				}
			
				LstEraseList(list);
				LstSetListChoices(list,(char**)NULL,0);
				if (g_pwad_listchoice) {
					int i;
					for (i=0;i<g_pwad_entries;i++)
						MemPtrFree(g_pwad_listchoice[i]);
					MemPtrFree(g_pwad_listchoice);
					g_pwad_listchoice=NULL;
				}				
				garbage_collect();
			}													
			break;
		}
		case ctlSelectEvent:{
			switch ( eventP->data.ctlSelect.controlID ) {			
				case PWADCHECK:{
					g_zhexen_pref.g_pwad_active=FrmGetControlValue (frmP,FrmGetObjectIndex(frmP,PWADCHECK));
					if (g_zhexen_pref.g_pwad_active){
						FrmShowObject(frmP,FrmGetObjectIndex(frmP,FORM_LISTPATCHFILE_ID));
					}else{
						FrmHideObject(frmP,FrmGetObjectIndex(frmP,FORM_LISTPATCHFILE_ID));
					}
					ASK_FOR_UPDATE
					handled=true;
					break;
				}
				case LaunchBUTTON:{
					Int16 idx;
					ListType *list;
					list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTFILE_ID) );
					idx=LstGetSelection(list);					
					idx=0;
					if ((idx>=0)&&(idx<g_iwad_entries)){
						char *ftrptr;
						if (!g_zhexen_pref.key_defined){
							menu_inform("You forgot to setup controls.");
							menu_inform("HOME won't exit the game. ");
							menu_inform("So setup controls carefully.");
							ASK_FOR_UPDATE
						}else{
							StrCopy(g_zhexen_pref.g_iwad_name,(g_iwad_listchoice[LstGetSelection(list)]));
							FtrPtrNew(CREATORID, FTR_WAD_FILENAME_ID , 256, (void **)&ftrptr);
							DmStrCopy(ftrptr,0,g_zhexen_pref.g_iwad_name);
							g_launch_pno=1;
						}
					}else{
						menu_inform("Please select an IWAD file.");
						ASK_FOR_UPDATE
					}
					
					if (g_launch_pno){
						char *ftrptr;
						list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTPATCHFILE_ID) );
						idx=LstGetSelection(list);
						FtrPtrNew(CREATORID, FTR_PWAD_FILENAME_ID , 256, (void **)&ftrptr);					
						if ((idx>=0)&&(idx<g_pwad_entries)&&g_zhexen_pref.g_pwad_active){
							char *ftrptr;
							StrCopy(g_zhexen_pref.g_pwad_name,(g_pwad_listchoice[LstGetSelection(list)]));
						}else{
							g_zhexen_pref.g_pwad_name[0]=0;
						}
						DmStrCopy(ftrptr,0,g_zhexen_pref.g_pwad_name);
					}
					
					handled=true;
					break;
				}
				case ControlsBUTTON:
//					g_prev_form=BlankForm;
					FrmGotoForm(ConfigForm);
					handled=true;
					break;
				case OptionsBUTTON:
					FrmGotoForm(OptionsForm);
					handled=true;
					break;
				case InfoBUTTON:
					menu_inform("ZHexen 1.1");
					menu_inform("Hexen (c) Raven Software");
					menu_inform("Palm Port : YoyoFR");
					menu_inform("http://yoyofr.fr.st");					
					ASK_FOR_UPDATE
					break;
			}
		}
		case lstSelectEvent:
/*			switch ( eventP->data.lstSelect.listID)	{
				case FORM_LISTFILE_ID:				
				if (eventP->data.lstSelect.selection<g_num_entries){					
					ASK_FOR_UPDATE
				}
				break;
			}*/
			break;
		case winEnterEvent:	
		case winDisplayChangedEvent:	
//			SysSetOrientation(sysOrientationLandscape);
//			PINSetInputAreaState(pinInputAreaClosed);
		case frmUpdateEvent:
			{//ydk_WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			DRAW_LOGO(8,2)			
			
			//ydk_WinScreenUnlock();
			}			
			handled=true;
			break;
			
		
	}
    
	return handled;
}

/***********************************************************************
 *
 * FUNCTION:    OptionsFormHandleEvent
 *
 * DESCRIPTION: This routine is the event handler for the "OptionsForm" of this 
 * 				application.
 *
 * PARAMETERS:  eventP - A pointer to the EventType structure.
 *
 * RETURNED:    true if the event was handled and should be passed to
 *				FrmHandleEvent.
 *
 ***********************************************************************/
Boolean OptionsFormHandleEvent(EventType * eventP)
{
	Boolean 		handled = false;
	FormType* 		frmP = FrmGetActiveForm();
	UInt32 			flags, pinMgrVersion;
	Err			err = errNone;

	switch (eventP->eType) {
		case frmOpenEvent:{	
			ListType *list;			
			
			SET_FRM_COLORS()
			FrmDrawForm(frmP);		
																		
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,FULLSCREENCHECK),g_zhexen_pref.g_fullscreen);
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,MUSICCHECK),g_zhexen_pref.g_music_mode);

			
			ASK_FOR_UPDATE

			handled = true;
			break;
		}
		case frmCloseEvent:{
													
			break;
		}
		case ctlSelectEvent:{
			switch ( eventP->data.ctlSelect.controlID ) {			
				case FULLSCREENCHECK:{
					g_zhexen_pref.g_fullscreen=FrmGetControlValue (frmP,FrmGetObjectIndex(frmP,FULLSCREENCHECK));
				//	ASK_FOR_UPDATE
					handled=true;
					break;
				}
				case MUSICCHECK:{
					g_zhexen_pref.g_music_mode=FrmGetControlValue (frmP,FrmGetObjectIndex(frmP,MUSICCHECK));
				//	ASK_FOR_UPDATE
					handled=true;
					break;
				}
				case OptionsFrmHOMEButton:
					FrmGotoForm(BlankForm);
					handled=true;
					break;
			}
		}
			break;
		case winEnterEvent:	
		case winDisplayChangedEvent:	
//			SysSetOrientation(sysOrientationLandscape);
//			PINSetInputAreaState(pinInputAreaClosed);
		case frmUpdateEvent:
			{//ydk_WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			DRAW_LOGO(8,2)			
			
			//ydk_WinScreenUnlock();
			}			
			handled=true;
			break;
			
		
	}
    
	return handled;
}


void ConfigFrmUpdateControls(FormType *frmP){
	Char strtmp[64],strtmp2[64];
	FieldType *field;
	UInt16	i,j,k;
	Char g_inputfld[2000];
	g_inputfld[0]=0;
	for (i=0;i<30;i++)
	if (g_zhexen_pref.g_inputconf[i]) {	
		k=0;
		strtmp[0]=0;
		for (j=0;hardkeys[j].val;j++){
			if (g_zhexen_pref.g_inputconf[i]==BTN_TR) {StrPrintF(strtmp,"S.TopRight");k=1;break;}
			if (g_zhexen_pref.g_inputconf[i]==BTN_TM) {StrPrintF(strtmp,"S.TopMid");k=1;break;}
			if (g_zhexen_pref.g_inputconf[i]==BTN_TL) {StrPrintF(strtmp,"S.TopLeft");k=1;break;}
			if (g_zhexen_pref.g_inputconf[i]==BTN_BR) {StrPrintF(strtmp,"S.BottomRight");k=1;break;}
			if (g_zhexen_pref.g_inputconf[i]==BTN_BM) {StrPrintF(strtmp,"S.BottomMid");k=1;break;}
			if (g_zhexen_pref.g_inputconf[i]==BTN_BL) {StrPrintF(strtmp,"S.BottomLeft");k=1;break;}
			if (g_zhexen_pref.g_inputconf[i]==BTN_ML) {StrPrintF(strtmp,"S.MidLeft");k=1;break;}
			if (g_zhexen_pref.g_inputconf[i]==BTN_MR) {StrPrintF(strtmp,"S.MidRight");k=1;break;}
			if (g_zhexen_pref.g_inputconf[i]&hardkeys[j].val){
				if (strtmp[0]) StrPrintF(strtmp2,"/%s",hardkeys[j].label);
				else StrPrintF(strtmp2,"%s",hardkeys[j].label);
				StrCat(strtmp,strtmp2);
				k=1;
				//j=0;
				//break;
			}
		}				
		if (!k) StrPrintF(strtmp,"%lx",g_zhexen_pref.g_inputconf[i]);			
		StrCat(g_inputfld,strtmp);					
		StrCat(g_inputfld,"\n");
	}else StrCat(g_inputfld,"none\n");
	field=(FieldType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTButtonField) );
	FldSetTextPtr(field,g_inputfld);
	FldRecalculateField (field,1);
}

/***********************************************************************
 *
 * FUNCTION:    ConfigFormHandleEvent
 *
 * DESCRIPTION: This routine is the event handler for the "ConfigForm" of this 
 * 				application.
 *
 * PARAMETERS:  eventP - A pointer to the EventType structure.
 *
 * RETURNED:    true if the event was handled and should be passed to
 *				FrmHandleEvent.
 *
 ***********************************************************************/
Boolean ConfigFormHandleEvent(EventType * eventP)
{
	Boolean 		handled = false;
	FormType* 		frmP = FrmGetActiveForm();
	UInt32 			flags, pinMgrVersion;
	Err			err = errNone;

	switch (eventP->eType) {
		case frmOpenEvent:{	
			ListType *list;
						
			SET_FRM_COLORS()
			FrmDrawForm(frmP);											
			
			
			
			ConfigFrmUpdateControls(frmP);
			ASK_FOR_UPDATE

			handled = true;
			break;
		}
		case frmCloseEvent:{
			break;
		}
		case ctlSelectEvent:{
			switch ( eventP->data.ctlSelect.controlID ) {			
				case ConfFrmHOMEButton:
					FrmGotoForm(BlankForm);
					handled=true;
					break;			
				case ConfFrmASSIGNButton:{				
					ListType *list;
					UInt32 i,j,k,old_mask;
					FieldType *field;
					list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTList) );
					i=LstGetSelection(list);									
					ydk_FadeScreen();					
					menu_messageXY(0,0,80,60,"TL",0x0AC00A);
					menu_messageXY(240,0,80,60,"TR",0x0AC00A);
 					menu_messageXY(0,120,80,60,"ML",0x0AC00A);
					menu_messageXY(240,120,80,60,"MR",0x0AC00A);
					menu_messageXY(0,260,80,60,"BL",0x0AC00A);
					menu_messageXY(240,260,80,60,"BR",0x0AC00A);
					menu_messageXY(120,0,80,60,"TM",0x0AC00A);
					menu_messageXY(120,260,80,60,"BM",0x0AC00A);
					
					menu_messageXY(158-60-40,204,80,30,"Cancel",0x80600A);
					menu_messageXY(158+60-40,204,80,30,"None",0x80600A);
					menu_messageXY(16,84,288,32,"Press a button or hit screen",0xC89664);
					old_mask=KeySetMask(~keyBitsAll);	
					if (menu_waitBtn(1,0,&k)) {	
						int l;
						if (k){
							g_zhexen_pref.key_defined=1;
							for (l=0;l<30;l++) 
								if (g_zhexen_pref.g_inputconf[l]==k) g_zhexen_pref.g_inputconf[l]=0;
						}
						g_zhexen_pref.g_inputconf[i]=k;
						ConfigFrmUpdateControls(frmP);
					}
					KeySetMask(old_mask/*keyBitsAll*/);
					
					if (i<LstGetNumberOfItems(list)-1) i++;
					LstSetSelection(list,i);
					
					field=(FieldType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTButtonField) );
					FldSetScrollPosition(field,0);				
					FldScrollField(field,LstGetTopItem(list),winDown);		
					ASK_FOR_UPDATE
				}								
			}
		}
		case penUpEvent:{
			ListType *list;		
			FieldType *field=(FieldType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTButtonField) );
			FldSetScrollPosition(field,0);				
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTList) );				
			FldScrollField(field,LstGetTopItem(list),winDown);		
			ASK_FOR_UPDATE			
			break;
		}
		case lstSelectEvent:
			break;
		case winEnterEvent:	
		case winDisplayChangedEvent:	
//			SysSetOrientation(sysOrientationLandscape);
//			PINSetInputAreaState(pinInputAreaClosed);
		case frmUpdateEvent:
			{//ydk_WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			DRAW_LOGO(8,2)			
			
			//ydk_WinScreenUnlock();
			}			
			handled=true;
			break;
			
		
	}
    
	return handled;
}

Boolean ConsoleFormHandleEvent(EventType * eventP)
{
	Boolean 		handled = false;
	FormType* 		frmP = FrmGetActiveForm();
	UInt32 			flags, pinMgrVersion;
	Err				err = errNone;
//	static int		frmloaded=0;
	

	switch (eventP->eType) {
		ListType *list;
		case frmOpenEvent:{						
			SET_FRM_COLORS()
			FrmDrawForm(frmP);
			FrmSetFocus(frmP,FrmGetObjectIndex(frmP,ConsoleDataField));
			g_consoleCmd[0]=0;
			
/*			if (g_cur_ggeniecode>=0){
				FldInsert((FieldType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,GGenieCodeDescriptionField)),
					g_ggenie_list[g_cur_ggeniecode].description,
					StrLen(g_ggenie_list[g_cur_ggeniecode].description));
				FldInsert((FieldType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,GGenieCodeDataField)),
					g_ggenie_list[g_cur_ggeniecode].code,
					StrLen(g_ggenie_list[g_cur_ggeniecode].code));
			}*/
			
			ASK_FOR_UPDATE	
			handled = true;
			break;
		}
		case frmCloseEvent:							
			break;
		case ctlSelectEvent:{
			switch ( eventP->data.ctlSelect.controlID ) {			
				case ConsoleOKButton:{
						char *data;
						data=FldGetTextPtr((FieldType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConsoleDataField)));
						if (data){							
							//FrmGotoForm(BlankForm);
							StrCopy(g_consoleCmd,data);
							g_launch_pno=1;
						}else {
							menu_inform("Please type something");
							ASK_FOR_UPDATE
						}
					}					
					handled=true;
					break;
				case ConsoleCancelButton:
					//FrmGotoForm(BlankForm);
					g_consoleCmd[0]=0;
					g_launch_pno=1;
					handled=true;
					break;	
			}
			break;			
		}
		case winEnterEvent:	
		case winDisplayChangedEvent:	
//			SysSetOrientation(sysOrientationLandscape);
//			PINSetInputAreaState(pinInputAreaClosed);
		case frmUpdateEvent:		
			{UInt8 *scr=WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			if (scr) WinScreenUnlock();
			}
			handled=true;
			break;
	}
	return handled;
}




/***********************************************************************
 *
 * FUNCTION:    AppHandleEvent
 *
 * DESCRIPTION: This routine loads form resources and set the event
 * 				handler for the form loaded.
 *
 * PARAMETERS:  eventP - A pointer to the EventType structure.
 *
 * RETURNED:    true if the event was handled and should not be passed
 *				to a higher level handler.
 *
 ***********************************************************************/
Boolean AppHandleEvent(EventType* eventP)
{
	UInt16 formId;
	FormType * frmP= FrmGetActiveForm();
	
	if (eventP->eType == frmLoadEvent)
	{
		/* Load the form resource. */
		formId = eventP->data.frmLoad.formID;
		frmP = FrmInitForm(formId);
		FrmSetActiveForm(frmP);
		/* 
		 * Set the event handler for the form.  The handler of the
		 * currently active form is called by FrmHandleEvent each
		 * time is receives an event. 
		 */
		switch (formId)
		{
			case BlankForm:
				FrmSetEventHandler( frmP, BlankFormHandleEvent );
				break;
			case ConfigForm:
				FrmSetEventHandler( frmP, ConfigFormHandleEvent );
				break;
			case OptionsForm:
				FrmSetEventHandler( frmP, OptionsFormHandleEvent );
				break;
			case ConsoleForm:
				FrmSetEventHandler( frmP, ConsoleFormHandleEvent );
				break;
		}
		return true;
	}		
	return false;
}


void AppEventLoop(void)
{
	UInt16 error;
	EventType event;


	do 
	{
		/* change timeout if you need periodic nilEvents */
		EvtGetEvent(&event, evtWaitForever);				

		if (! SysHandleEvent(&event))
		{
			if (! AppHandleEvent(&event))
			{
				if (! MenuHandleEvent(0, &event, &error))
				{
					FrmDispatchEvent(&event);
				}	
			}		
		}		
		if (g_launch_pno) break;
	} while (event.eType != appStopEvent);
}

void AppStop(void)
{
/*SAVE PREF*/
	PrefSetAppPreferences(CREATORID,0x0001,(short)VERSION_DB,(void*)NULL,(short)0,(unsigned char)1);
	PrefSetAppPreferences(CREATORID,0x0001,(short)VERSION_DB,(void*)&g_zhexen_pref,(short)sizeof(g_zhexen_pref),(unsigned char)1);
	FrmCloseAllForms();
		
}

void CheckDirs(void)
{
	UInt16 volRefNum;			
	UInt32 volIterator; 
	Err err;
	
	volIterator = vfsIteratorStart;
	while (volIterator != vfsIteratorStop) 
	{
		err = VFSVolumeEnumerate(&volRefNum, &volIterator);
		if (!err) {
		    VFSDirCreate(volRefNum,VFSPATH);
		 }
	}
}


void InitPrefDefaultValues(){	
	MemSet(&g_zhexen_pref,0,sizeof(g_zhexen_pref));	
}

UInt32 query_heap_free ( void ) {
  UInt16 heapid = 0;
  UInt32 max, bytes;

  MemHeapFreeBytes ( heapid, &bytes, &max );

  //DEBUGS ( "heapfree" );
  //DEBUGU32 ( bytes );

  return ( max );
}


void garbage_collect ( void ) {

  /* on failure, compact memory */
  //MemHeapCompact ( MemPtrHeapID ( true_head() ) );

//#ifdef RSRC
  MemPtr ptr=MemPtrNew(8);	
  UInt16 heap_id=MemPtrHeapID(ptr);
  MemPtrFree(ptr);
  MemHeapCompact ( heap_id );
//#endif

  return;
}


void LoadZippedModuleFromCard(/*UInt16 id*/char *name)
{	
  UInt32 processor;
  UInt32 flags = 0;
  ControlType *c;
  FormPtr frmP = FrmGetActiveForm();
  UInt8 filetype;
  Err res;
  UInt16 initDelay,old_initDelay,old_initDblDelay;
  UInt16 period,old_period;
  UInt32 old_mask;
  Boolean queueAhead,old_queueAhead;
  MemPtr pnoPtr,ptr;
  PnoDescriptor pno;
/*  char *name;  
  MemHandle memh;
  FILE *f;
  name="tmp.pno";
  memh = DmGetResource('YDKC', id);
  if (!memh) {DEBUGS("Error while accessing pno resource");return;}
  ptr = MemHandleLock(memh);
  f=fopen("tmp.pno","wb");
  if (!f) {DEBUGS("Cannot write temp pno"); return;}
  fwrite(ptr,1,MemPtrSize(ptr),f);
  fclose(f);
  MemHandleUnlock(memh);
	DmReleaseResource(memh);
  */


//  StrPrintF(name,"%1d:%s%s",palm_vfs_iter(),VFSPATH,_name);
#ifdef TESTING_ONLY	
	return;
#endif	  
  // does emu module exist?
  {
    FILE *f = fopen ( name, "r" );
    if ( ! f ) {
      DEBUGS ( "The emulation module to run this game is not present." );
      DEBUGS (name);
      return;
    }
    fclose ( f );
  }
  // clear background
  {
    RectangleType r;
    IndexedColorType c;
    r.topLeft.x = 0;
    r.topLeft.y = 16;
    r.extent.x = 160;
    r.extent.y = 160 - 16;
    c = WinSetBackColor ( 0 );
    WinDrawRectangle ( &r, 0 );
    WinSetBackColor ( c );
  }
  // call the PACE Native Object
  FtrGet(sysFtrCreator, sysFtrNumProcessorID, &processor);
  // rearrange memory
  garbage_collect();
  // fire up pno
  if ( sysFtrNumProcessorIsARM ( processor ) )
  {
    pnobridge_t *bridge = (pnobridge_t*) MemPtrNew ( sizeof(pnobridge_t) );
    MemHandle mh;
    UInt8 *tmpPtr;
    UInt16 pitch, width, height;
    Err error;

    hw_guess_screen_dimensions ( &width, &height, &pitch );
    bridge -> vram = (UInt32) hw_query_vram();
    bridge -> eventf = (UInt32) host_event_handler;
    bridge -> display_width = width;
    bridge -> display_height = height;
    bridge -> display_pitch = pitch;
    
    bridge -> param1 = NULL;
    
    bridge -> param2 = NULL;
    bridge -> flags = (hw_flags&hf_pin_present?BF_HASPIN:0)|
    				(device_type&_ZODIAC_DEVICE_?BF_ZODIAC:0)|
    				(device_type&_HIRES_PLUS_DEVICE_?BF_HIRESPLUS:0);

    UnzipToFtr(name,FTR_PNO);
	FtrGet(CREATORID, FTR_PNO, (void*)&pnoPtr);		

    res=ydk_PnoLoad ( &pno, pnoPtr );
    FtrPtrFree ( CREATORID, FTR_PNO ); 
    if (res) {
		DEBUGS("Error while loading PNO");
		DEBUGU32(res);
		MemPtrFree(bridge);
		return;    	
    }
	old_mask=KeySetMask(~keyBitsAll);		
	initDelay=slowestKeyDelayRate;
	period=slowestKeyPeriodRate;
	queueAhead=false;
	KeyRates(false,&old_initDelay,&old_period,&old_initDblDelay,&old_queueAhead);
	KeyRates(true,&initDelay,&period,&initDelay,&queueAhead);
	//read memory to flush D cache
	FLUSH_D_CACHE	
//	FtrSet(CREATORID, FTR_OPT_SHOWFRAMERATE_ID,g_ljp_pref.g_showFramerate);		

    res = ydk_PnoCall ( &pno, bridge );        
//    FtrUnregister(CREATORID, FTR_OPT_SHOWFRAMERATE_ID);
	//free sys event
	{
		EventType myevent;
		for (;;)
		{
			EvtGetEvent(&myevent,0);
			if (myevent.eType==nilEvent) break;
			//SysHandleEvent(&myevent);
		}
	}
	KeySetMask(old_mask/*keyBitsAll*/);
	KeyRates(true,&old_initDelay,&old_period,&old_initDblDelay,&old_queueAhead);
	
	//unload pno
	res=ydk_PnoUnload ( &pno );
    if (res) {DEBUGS("Error while loading PNO, probably not enough free ram.");DEBUGS(name);}
    MemPtrFree(bridge);
    
//    remove("tmp.pno");
   // rearrange memory
    garbage_collect();
  } // is arm and rom picked
}

UInt32 UnzipToFtr(char *name,UInt16 Ftr){
	MemHandle memh;
	MemPtr ptr;
	PnoDescriptor pno;
	UInt32 res;
	pnobridge_t *bridge;	
	UInt16 pitch, width, height;
	
	memh = DmGetResource('YDKC', PNO_ZLIB);
	if (!memh) {DEBUGS("Error while accessing zlib resource");return 1;}
	ptr = MemHandleLock(memh);
	if (!ptr){DEBUGS("Error while locking zlib resource");return 2;}	
	res=ydk_PnoLoad ( &pno, ptr );
    FtrPtrFree ( CREATORID, FTR_PNO ); 
    if (res) {DEBUGS("Error while loading zlib pno");return 3;}
	//read memory to flush D cache
	FLUSH_D_CACHE

    bridge = (pnobridge_t*) MemPtrNew ( sizeof(pnobridge_t) );
    hw_guess_screen_dimensions ( &width, &height, &pitch );
    bridge -> vram = (UInt32) hw_query_vram();
    bridge -> eventf = (UInt32) host_event_handler;
    bridge -> display_width = width;
    bridge -> display_height = height;
    bridge -> display_pitch = pitch;
    bridge -> param1 = (unsigned long)name;
    bridge -> param2 = (unsigned long)Ftr;
    bridge -> flags = BF_UNZIP;
    
    if (res=ydk_PnoCall ( &pno, bridge )) {DEBUGS("Error while unzipping");DEBUGU32(res);return 4;}
    MemPtrFree(bridge);
	//unload pno
	res=ydk_PnoUnload ( &pno );    		
    if (res) {DEBUGS("Error while loading PNO(ZIP), probably not enough free ram.");}
   // rearrange memory
	garbage_collect();
	 		
	MemHandleUnlock(memh);
	DmReleaseResource(memh);
}



UInt32 LaunchPNO(){
	char *ptr;
	UInt32 val;													  					  					  					  					
	RectangleType rclip;
	UInt16 err;
	UInt8 res;
	
	
	
	WinHandle runningWnd,oldWnd;
	rclip.topLeft.x=0;
	rclip.topLeft.y=0;
	rclip.extent.x=160;
	rclip.extent.y=160;		
	oldWnd=WinGetActiveWindow();
	runningWnd=WinCreateWindow( &rclip,noFrame,false,true, &err );
	if (err) runningWnd=NULL;														  					
	if (runningWnd)	{
		WinSetActiveWindow(runningWnd);
									
		LoadZippedModuleFromCard(/*PNO_ZDOOM*/ "zhexen.zdk");
																									
		if (runningWnd) WinDeleteWindow(runningWnd,false);
		else DEBUGS("cannot free window");
		WinSetActiveWindow(oldWnd);																				
	}
	else 
	{
		DEBUGS("Error : cannot create runningWnd");	
	}	
	return 0;								
}

UInt32 AppMain(void)
{
	UInt32 res = errNone;
	UInt16 exit_main=0;
	

	
		if ( ! hw_set16bpp() ) {
   			 DEBUGS ( "Couldn't set to 16 bit colour!" );
   			 exit_main=1;
   		}
   		
		g_launch_pno=0;		
		p_video_x=p_video_y=320;p_video_rot=0;

   		device_type=0;  		
   		
		{	UInt16 pitch, width, height;	
	    	hw_guess_screen_dimensions ( &width, &height, &pitch );
	    	if (hw_flags & hf_pin_present/*(pitch>320)||(width>320)||(height>320)*/) {
	    		device_type=_HIRES_PLUS_DEVICE_;	    		
	    	}
	    }	    	    
//	    if (is_zodiac()) {device_type|=_ZODIAC_DEVICE_;g_fullscreen=1;}
   		if (is_clie()) device_type|=_CLIE_DEVICE_;
   		
   		
   		
		
		if (!exit_main)
		{			
			unsigned short val;				
			char c;
			/*Setup dir if necessary*/
			CheckDirs();
			/*Register file type for emu module*/
			VFSUnregisterDefaultDirectory(".zdk", expMediaType_Any);
			VFSRegisterDefaultDirectory ( ".zdk", expMediaType_Any, VFSPATH );
		
			

			/* DEFAULT PREF */
			InitPrefDefaultValues();
									
			/* LOAD PREF IF AVAILABLE WITH GOOD VERSION NUMBER*/
			
			val=1;
			if (PrefGetAppPreferences(CREATORID,0x0001,(void*)&c,(unsigned short*)&val,(unsigned char)1)==VERSION_DB);
			{
				val=sizeof(g_zhexen_pref);
				PrefGetAppPreferences(CREATORID,0x0001,(void*)&g_zhexen_pref,(unsigned short*)&val,(unsigned char)1);
			}
			
			/* init random seed */
			SysRandom(TimGetTicks());
									
	
			if (FrmGetActiveFormID()!=BlankForm)
				FrmGotoForm( BlankForm );
			else FrmUpdateForm( BlankForm ,0);
												
			AppEventLoop();
			AppStop();
			
			
			if (g_launch_pno){
				char *ptr;
				
				// Switch to fullscreen if choosed
				// and read current screen size
				// eventually turn on software landscape if necessary
				if (g_zhexen_pref.g_fullscreen) {hw_set_FullscreenGraf(1);}
				if (device_type&_ZODIAC_DEVICE_) {if (res=tw_gfx_init()) {DEBUGS("Cannot init Zodiac gfx");DEBUGU32(res);}}
				{	UInt16 pitch, width, height;
			    	hw_guess_screen_dimensions ( &width, &height, &pitch );			    	
			    	if (width==480){
			    		p_video_x=480;
			    		p_video_y=320;
			    	}
			    	if (height==480){			    		
				    	p_video_x=480;
			    		p_video_y=320;
			    		p_video_rot=1;
			    	}
			    }
				
				FtrSet(CREATORID, FTR_VIDEO_RESX_ID,p_video_x);	
				FtrSet(CREATORID, FTR_VIDEO_RESY_ID,p_video_y);	
				FtrSet(CREATORID, FTR_VIDEO_ROT_ID,p_video_rot);
				FtrSet(CREATORID, FTR_MUSIC_MODE_ID,g_zhexen_pref.g_music_mode);
				FtrPtrNew(CREATORID, FTR_OPT_INPUTCONF_ID, 30*4, (void**)&ptr);
				DmWrite(ptr,0,(void*)&(g_zhexen_pref.g_inputconf[0]),30*4);				
				LaunchPNO();								
				FtrPtrFree(CREATORID, FTR_OPT_INPUTCONF_ID);				
				FtrUnregister(CREATORID, FTR_VIDEO_RESX_ID);
				FtrUnregister(CREATORID, FTR_VIDEO_RESY_ID);
				FtrUnregister(CREATORID, FTR_VIDEO_ROT_ID);
				FtrUnregister(CREATORID, FTR_MUSIC_MODE_ID);
				
				if (device_type&_ZODIAC_DEVICE_) {tw_gfx_close();}
				if (g_zhexen_pref.g_fullscreen) {hw_set_FullscreenGraf(0);}	
			}
			

        }


}

/***********************************************************************
 *
 * FUNCTION:    RomVersionCompatible
 *
 * DESCRIPTION: This routine checks that a ROM version is meet your
 *              minimum requirement.
 *
 * PARAMETERS:  requiredVersion - minimum rom version required
 *                                (see sysFtrNumROMVersion in SystemMgr.h 
 *                                for format)
 *              launchFlags     - flags that indicate if the application 
 *                                UI is initialized.
 *
 * RETURNED:    error code or zero if rom is compatible
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static Err RomVersionCompatible(UInt32 requiredVersion, UInt16 launchFlags)
{
	UInt32 romVersion;

	// See if we're on in minimum required version of the ROM or later.
	FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion);
	if (romVersion < requiredVersion)
		{
		if ((launchFlags & (sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp)) ==
			(sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp))
			{
			FrmAlert (RomIncompatibleAlert);
		
			// Palm OS 1.0 will continuously relaunch this app unless we switch to 
			// another safe one.
			if (romVersion <= kPalmOS10Version)
				{
				AppLaunchWithCommand(sysFileCDefaultApp, sysAppLaunchCmdNormalLaunch, NULL);
				}
			}
		
		return sysErrRomIncompatible;
		}

	return errNone;
}


/***********************************************************************
 *
 * FUNCTION:    PilotMain
 *
 * DESCRIPTION: This is the main entry point for the application.
 *
 * PARAMETERS:  cmd - word value specifying the launch code. 
 *              cmdPB - pointer to a structure that is associated with the launch code. 
 *              launchFlags -  word value providing extra information about the launch.
 * RETURNED:    Result of launch
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
    NativeFuncType* entry;
    UInt32 res;
	
	if (cmd == sysAppLaunchCmdNormalLaunch) 
	{	
		res=0;
		if (!RomVersionCompatible(kOurMinVersion, launchFlags)) 
			res=AppMain();		
		
	}

	
	return res;
}
